/// <reference types="node" />
import { Writable } from 'stream';
import { Socket } from 'net';
import { ServerResponse as HttpServerResponse, OutgoingHttpHeaders } from 'http';
/**
 * A mock response used to simluate the server response to mock requests during
 * tests. You shouldn't need to instantiate these directly - instead, use an
 * AppAcceptance test.
 *
 * @package test
 */
export default class MockResponse extends Writable implements HttpServerResponse {
    statusCode: number;
    readonly statusMessage: string;
    _headers: OutgoingHttpHeaders;
    upgrading: boolean;
    chunkedEncoding: boolean;
    shouldKeepAlive: boolean;
    useChunkedEncodingByDefault: boolean;
    sendDate: boolean;
    finished: boolean;
    headersSent: boolean;
    connection: Socket;
    protected _customStatusMessage: string;
    _body: string;
    _json: any;
    constructor(callback?: (result: {
        status: number;
        body: string;
        json: any;
    }) => void);
    write(chunk: Buffer | string, encoding?: string | Function, cb?: Function): boolean;
    _implicitHeader(): void;
    setHeader(name: string, value: number | string | string[]): void;
    getHeader(name: string): string | number | string[];
    getHeaders(): OutgoingHttpHeaders;
    getHeaderNames(): string[];
    hasHeader(name: string): boolean;
    removeHeader(name: string): void;
    addTrailers(headers: OutgoingHttpHeaders | [string, string][]): void;
    flushHeaders(): void;
    writeHead(statusCode: number, statusMessage?: string | OutgoingHttpHeaders, headers?: OutgoingHttpHeaders): void;
    writeContinue(): void;
    assignSocket(socket: Socket): void;
    detachSocket(socket: Socket): void;
    setTimeout(msecs: number, callback?: () => void): this;
}
